CREATE TABLE "order" ("o_id"           NUMBER GENERATED BY DEFAULT AS IDENTITY, "Total"          NUMBER(12,2)         default 0, CONSTRAINT PK_ORDER primary key ("o_id"))
CREATE TABLE "order_item" ("oi_id"	NUMBER	GENERATED BY DEFAULT AS IDENTITY, "order_id"  NUMBER, "product_id" NUMBER	NOT NULL, "Price"	NUMBER(12,2)  default 0	NOT NULL, CONSTRAINT PK_ORDERITEM primary key ("oi_id"))
CREATE TABLE "product" ("p_id"       NUMBER                     GENERATED BY DEFAULT AS IDENTITY,"name"       VARCHAR2(200)           NOT NULL,CONSTRAINT PK_PRODUCT PRIMARY KEY ("p_id"))
alter table "order_item" add CONSTRAINT FK_ORDERITE_REFERENCE_ORDER foreign key ("order_id") references "order"("o_id")
ALTER TABLE "order_item" ADD CONSTRAINT FK_PRODUCT_ITEM FOREIGN KEY ("product_id") REFERENCES "product"("p_id")
CREATE TABLE "actor" ("a_id"    NUMBER GENERATED BY DEFAULT AS IDENTITY, "name"    VARCHAR2(200)   NOT NULL, "photo"   BLOB, CONSTRAINT PK_ACTOR PRIMARY KEY ("a_id"))
CREATE TABLE "movie" ("m_id"    NUMBER GENERATED BY DEFAULT AS IDENTITY, "name" VARCHAR2(200) NOT NULL, "file"   BLOB, CONSTRAINT PK_MOVIE PRIMARY  KEY ("m_id"))
CREATE TABLE "actor_movie" ("a_id" NUMBER NOT NULL, "m_id" NUMBER NOT NULL, CONSTRAINT PK_ACTOR_MOVIE PRIMARY KEY ("a_id", "m_id"))
ALTER TABLE "actor_movie" ADD CONSTRAINT FK_ACTOR FOREIGN KEY ("a_id") REFERENCES "actor"("a_id")
ALTER TABLE "actor_movie" ADD CONSTRAINT FK_MOVIE FOREIGN KEY ("m_id") REFERENCES "movie"("m_id")
CREATE TABLE "groups1" ("g_id"   NUMBER GENERATED BY DEFAULT AS IDENTITY, "name" VARCHAR2(20) NOT NULL, "parent_group_id" NUMBER, CONSTRAINT PK_GROUPS1 PRIMARY KEY ("g_id"))
ALTER TABLE "groups1" ADD CONSTRAINT FK_PARENT_GROUP FOREIGN KEY ("parent_group_id") REFERENCES "groups1"("g_id")
CREATE TABLE "orders2" ("o_id"           NUMBER                  GENERATED BY DEFAULT AS IDENTITY, "customer_vatid"         NUMBER,CONSTRAINT PK_ORDER2 primary key ("o_id"))
CREATE TABLE "customers2" ("c_id"       NUMBER GENERATED BY DEFAULT AS IDENTITY, "vatid"      NUMBER NOT NULL, CONSTRAINT PK_CUSTOMERS2 primary key ("c_id"))
CREATE UNIQUE INDEX C2_VAT_ID ON "customers2" ( "vatid" )
