CREATE TABLE NoPkTable (Id                  NUMBER                 GENERATED BY DEFAULT AS IDENTITY)
CREATE TABLE UnsupportedTable (Id                  NUMBER                 GENERATED BY DEFAULT AS IDENTITY, Node                 point           not null,constraint PK_UnsupportedTable primary key (Id) )
CREATE TABLE Customer (Id                  NUMBER                 GENERATED BY DEFAULT AS IDENTITY,FirstName            VARCHAR2(40)         not null,Pic			        BLOB	     ,constraint PK_CUSTOMER primary key (Id))
CREATE TABLE "Order" (Id                  NUMBER                 GENERATED BY DEFAULT AS IDENTITY,OrderDate            timestamp DEFAULT sysdate NOT NULL,CustomerId          NUMBER                 not null,TotalAmount          NUMERIC(12,2)         default 0,constraint PK_ORDER primary key (Id))
CREATE TABLE OrderItem (  OrderId             NUMBER                 GENERATED BY DEFAULT AS IDENTITY,ProductId           NUMBER                 not null, UnitPrice            NUMERIC(12,2)    default 0     not null,constraint PK_ORDERITEM primary key (OrderID, ProductID))
CREATE TABLE Details (     ID                  NUMBER                 GENERATED BY DEFAULT AS IDENTITY,   OrderId             NUMBER                 not null,   ProductId           NUMBER                 not null, Name			        VARCHAR2(30)	     , constraint PK_DETAILS primary key (ID, OrderID, ProductID))
CREATE TABLE Product ( Id                  NUMBER                 GENERATED BY DEFAULT AS IDENTITY,   UnitPrice            NUMERIC(12,2)         default 0,   IsDiscontinued       number(1)        default 0          not null,   constraint PK_PRODUCT primary key (Id))
CREATE TABLE Category (   Id                  NUMBER                 GENERATED BY DEFAULT AS IDENTITY,   Name			        VARCHAR2(30)	     not null,   constraint PK_CATEGORY primary key (Id))
CREATE TABLE ProductCategory (   ProductId             NUMBER                 not null,   CategoryId            NUMBER                 not null,   constraint PK_PRODUCT_CATEGORY primary key (ProductId, CategoryId))
CREATE TABLE Photo (    Id			NUMBER 		             GENERATED BY DEFAULT AS IDENTITY, Pic			BLOB	     ,	    Photographer	NUMBER 		             ,   InPic1		NUMBER                   ,   InPic2		NUMBER 		             ,   constraint PK_Photo primary key (Id))
alter table "Order" add constraint FK_ORDER_REFERENCE_CUSTOMER foreign key (CustomerId) references Customer(Id)
alter table OrderItem add constraint FK_ORDERITE_REFERENCE_ORDER foreign key (OrderId) references "Order"(Id)
alter table Details add constraint FK_Details_REFERENCE_ORDERITEM foreign key (OrderId, ProductId) references OrderItem(OrderId, ProductId)
alter table OrderItem add constraint FK_ORDERITE_REFERENCE_PRODUCT foreign key (ProductId) references Product(Id)
alter table Photo add constraint FK_ORDERITE_REFERENCE_CUSTOMER1 foreign key (Photographer) references Customer(Id)
alter table Photo add constraint FK_ORDERITE_REFERENCE_CUSTOMER2 foreign key (InPic1) references Customer(Id)
alter table Photo add constraint FK_ORDERITE_REFERENCE_CUSTOMER3 foreign key (InPic2) references Customer(Id)
ALTER TABLE ProductCategory ADD constraint FK_PROD_CAT_REF_PROD FOREIGN KEY (ProductId) REFERENCES Product(Id)
ALTER TABLE ProductCategory ADD constraint FK_PROD_CAT_REF_CAT FOREIGN KEY (CategoryId) REFERENCES Category(Id)
CREATE VIEW john_customers AS SELECT * FROM Customer WHERE FirstName = 'John'
